//@: Willy Young
//v: Creative Commons
//Lm{ƶG o{ Bug Oonq@nǡII
//@@@@@@@ ٦{ա㤣n ^^;

module_name = "Unicode Converter";
module_ver = "0.002";

//UTӨ禡GUnicodeToUcnBUcnToUnicodeBUniALLToUcn \DnOFϧOugഫvPuuഫϡvC
function UnicodeToUcn(){//Unicode ഫ Universal Character Name (UCN)A]t ASCII (YϬq 0x00 ~ 0xFF)C
	var editor = newEditor();

	if(editor.assignActiveEditor()){
		if(editor.selText().length != 0) editor.selText(encodeUcn(editor.selText()));
		else editor.text(encodeUcn(editor.text()));
	}
}
         
function UcnToUnicode(){//UCN ഫ^ UnicodeC
	var editor = newEditor();

	if(editor.assignActiveEditor()){
		if(editor.selText().length != 0) editor.selText(decodeUcn(editor.selText()));
		else editor.text(decodeUcn(editor.text()));
	}
}

function UniALLToUcn(){//r (tASCII) ഫ UCNC
	var editor = newEditor();

	if(editor.assignActiveEditor()){
		if(editor.selText().length != 0) editor.selText(encodeAll(editor.selText()));
		else editor.text(encodeAll(editor.text()));
	}
}

//UCN sX禡GN ASCII ~rഫ UCNC
function encodeUcn(unicodeString){
	var ucnString = "";
	var codeNum = 0;

	for(var i=0; i < unicodeString.length; i++){
		codeNum = Number(unicodeString.charCodeAt(i));
		if(codeNum <= 255) ucnString += unicodeString.charAt(i); //ASCII Bz
		else ucnString += "\\u" + codeNum.toString(16);
	}
	return ucnString;
}

//UCN ѽX禡G٭ UCN sX Unicode rC
function decodeUcn(ucnString){
	var unicodeString = "";
	var i = 0;
	var minCompLength = ucnString.length-5; //uoӦmAbX{ UCN khrŮɤ]OҤO㪺 UCNC
	var tmpString = "";

	while(i < minCompLength){
		if(ucnString.charAt(i) == '\\' && ucnString.charAt(i+1) == 'u'){
			tmpString = ucnString.substr(i+2,4);
			if(tmpString.indexOf("\\") == -1){ //Y UCN header 襼X{khršAh UCN C
				unicodeString += String.fromCharCode("0x" + tmpString);
				i+=6;
			}
			else{//u\uvAo{᭱|Ӧr̦khršC
				unicodeString += ucnString.substr(i,2);
				i+=2;
			}
		}
		else{//䤣u\uvpANmrwഫrC
			unicodeString += ucnString.substr(i,1);
			i++;
		}
	}

	//Yr̫᤻ӦrO UCNANɨwഫrꪺڤWhC
	if(ucnString.charAt(minCompLength-1) != '\\' || ucnString.charAt(minCompLength) != 'u' || tmpString.indexOf("\\") != -1){
		unicodeString += ucnString.substr(minCompLength);
	}
	
	return unicodeString;
}

//UCN sX禡GഫҦr (t ASCII)  UCN ܪkC
function encodeAll(unicodeString){
	var ucnString = "";
	var zeroString = "0000"; //] ASCII rഫ|ܦu\u??v榡(? i঳ 1~3 )AҥHbe 0AHΤ@sXסC
	var codeStr = "";

	for(var i=0; i < unicodeString.length; i++){
	    codeStr = Number(unicodeString.charCodeAt(i)).toString(16);
		ucnString += "\\u" + zeroString.substr(0,4-codeStr.length) + codeStr;
	}
	return ucnString;
}

//oO PSPad Mҩl禡AaddMenuItem ѼƥΪkO addMenuItem(涵, Wh涵, Is禡)
function Init(){
	addMenuItem("UnicodeUCN", "Unicode Converter", "UnicodeToUcn");
	addMenuItem("UCNUnicode", "Unicode Converter", "UcnToUnicode");
	addMenuItem("UniALLUCN", "Unicode Converter", "UniALLToUcn");
}

